#define KEYFILE "/etc/auth.keys"
#define NEW_KEYFILE "/etc/auth.keys.new"

#define DOMLEN 48
#define CHALLEN 8
#define NAMELEN 28
#define NETCHLEN 16
#define ERRLEN 64
#define DESKEYLEN 7

#define AuthTreq 1
#define AuthChal 2
#define AuthPass 3

#define AuthOK 4
#define AuthErr 5

#define AuthTs 64
#define AuthTc 65
#define AuthAs 66
#define AuthAc 67

#define MAXNETCHAL 100000

typedef struct Ticketreq {
	char type;
	char authid[NAMELEN];
	char authdom[DOMLEN];
	char chal[CHALLEN];
	char hostid[NAMELEN];
	char uid[NAMELEN];
} Ticketreq;
#define TICKREQLEN (3 * NAMELEN + CHALLEN + DOMLEN + 1)

typedef struct Ticket {
	char num;
	char chal[CHALLEN];
	char cuid[NAMELEN];
	char suid[NAMELEN];
	char key[DESKEYLEN];
} Ticket;
#define TICKETLEN (CHALLEN + 2 * NAMELEN + DESKEYLEN + 1)

typedef struct Authenticator {
	char num;
	char chal[CHALLEN];
	unsigned long id;
} Authenticator;
#define AUTHENTLEN (CHALLEN+4+1)

void convM2TR (char *, struct Ticketreq *);
int convT2M (struct Ticket *, char *, char *);
int convA2M (struct Authenticator *, char *, char *);

/* bsd has a different encrypt */
int plan9_encrypt (void *keyarg, void *data, int len);

int passtokey (char *key, char *p);

int netcrypt(void *key, void *chal);

int netcheck(void *key, long chal, char *response);

